| API Documentation |  |

- MAIN PAGE
- NAMESPACES
- CLASSES

Public Member Functions | List of all members
nkGraphics::ResourceManager Class Reference

Generic resource manager, enabling more intelligent processing of resources, compared to the ContentLoader. More...

Inheritance diagram for nkGraphics::ResourceManager:

## Public Member Functions
void | loadResourceSetDescFileSync (const ResourceSetLoadQuery &query, ResourceSetLoadResult &resultRef)
void | loadResourceSetDescFileAsync (const ResourceSetLoadQuery &query, ResourceSaveLoadCallback *callback=nullptr)
void | saveResourceSetDescFile (const ResourceSetSaveQuery &query)
void | loadCamera (nkMemory::StringView path, ResourceSaveLoadCallback *callback=nullptr)
void | loadBlendState (nkMemory::StringView path, ResourceSaveLoadCallback *callback=nullptr)
void | loadDepthStencilState (nkMemory::StringView path, ResourceSaveLoadCallback *callback=nullptr)
void | loadRasterState (nkMemory::StringView path, ResourceSaveLoadCallback *callback=nullptr)
void | loadSampler (nkMemory::StringView path, ResourceSaveLoadCallback *callback=nullptr)
void | loadTexture (nkMemory::StringView path, ResourceSaveLoadCallback *callback=nullptr)
void | loadBuffer (nkMemory::StringView path, ResourceSaveLoadCallback *callback=nullptr)
void | loadShader (nkMemory::StringView path, ResourceSaveLoadCallback *callback=nullptr)
void | loadProgram (nkMemory::StringView path, ResourceSaveLoadCallback *callback=nullptr)
void | loadMesh (nkMemory::StringView path, ResourceSaveLoadCallback *callback=nullptr)
void | loadCompositor (nkMemory::StringView path, nkMemory::StringView compoToDefault="", ResourceSaveLoadCallback *callback=nullptr)
void | loadNode (nkMemory::StringView path, ResourceSaveLoadCallback *callback=nullptr)

## Detailed Description

Generic resource manager, enabling more intelligent processing of resources, compared to the ContentLoader.

## Member Function Documentation

## ◆ loadResourceSetDescFileSync()

void nkGraphics::ResourceManager::loadResourceSetDescFileSync | ( | const ResourceSetLoadQuery & | query,
|  | ResourceSetLoadResult & | resultRef
| ) |  |

Requests to load a resource set, synchronously.

Parameters

  query | The resource set load query.
  resultRef | The result to populate.

Remarks
  Currently WIP. This will change.

## ◆ loadResourceSetDescFileAsync()

void nkGraphics::ResourceManager::loadResourceSetDescFileAsync | ( | const ResourceSetLoadQuery & | query,
|  | ResourceSaveLoadCallback * | callback = `nullptr`
| ) |  |

Requests to load a resource set, asynchronously.

Parameters

  query | The resource set load query.
  callback | The callback interface to use.

Remarks
  Currently WIP. This might change and / or work in an unexpected way.

## ◆ saveResourceSetDescFile()

void nkGraphics::ResourceManager::saveResourceSetDescFile | ( | const ResourceSetSaveQuery & | query | ) |

Requests to save a resource set, Synchronously.

Parameters

  query | The resource set save query.

## ◆ loadCamera()

void nkGraphics::ResourceManager::loadCamera | ( | nkMemory::StringView | path,
|  | ResourceSaveLoadCallback * | callback = `nullptr`
| ) |  |

Loads a camera declaration file. Does it asynchronously.

Parameters

  path | The declaration path, relative to the working directory. See nkResources::ResourceManager for path naming conventions.
  callback | The callback used for resource loading.

Remarks
  Currently WIP. This might change and / or work in an unexpected way.

## ◆ loadBlendState()

void nkGraphics::ResourceManager::loadBlendState | ( | nkMemory::StringView | path,
|  | ResourceSaveLoadCallback * | callback = `nullptr`
| ) |  |

Loads a blend state declaration file. Does it asynchronously.

Parameters

  path | The declaration path, relative to the working directory. See nkResources::ResourceManager for path naming conventions.
  callback | The callback used for resource loading.

Remarks
  Currently WIP. This might change and / or work in an unexpected way.

## ◆ loadDepthStencilState()

void nkGraphics::ResourceManager::loadDepthStencilState | ( | nkMemory::StringView | path,
|  | ResourceSaveLoadCallback * | callback = `nullptr`
| ) |  |

Loads a depth and stencil state declaration file. Does it asynchronously.

Parameters

  path | The declaration path, relative to the working directory. See nkResources::ResourceManager for path naming conventions.
  callback | The callback used for resource loading.

Remarks
  Currently WIP. This might change and / or work in an unexpected way.

## ◆ loadRasterState()

void nkGraphics::ResourceManager::loadRasterState | ( | nkMemory::StringView | path,
|  | ResourceSaveLoadCallback * | callback = `nullptr`
| ) |  |

Loads a raster state declaration file. Does it asynchronously.

Parameters

  path | The declaration path, relative to the working directory. See nkResources::ResourceManager for path naming conventions.
  callback | The callback used for resource loading.

Remarks
  Currently WIP. This might change and / or work in an unexpected way.

## ◆ loadSampler()

void nkGraphics::ResourceManager::loadSampler | ( | nkMemory::StringView | path,
|  | ResourceSaveLoadCallback * | callback = `nullptr`
| ) |  |

Loads a sampler declaration file. Does it asynchronously.

Parameters

  path | The declaration path, relative to the working directory. See nkResources::ResourceManager for path naming conventions.
  callback | The callback used for resource loading.

Remarks
  Currently WIP. This might change and / or work in an unexpected way.

## ◆ loadTexture()

void nkGraphics::ResourceManager::loadTexture | ( | nkMemory::StringView | path,
|  | ResourceSaveLoadCallback * | callback = `nullptr`
| ) |  |

Loads a texture declaration file. Does it asynchronously.

Parameters

  path | The declaration path, relative to the working directory. See nkResources::ResourceManager for path naming conventions.
  callback | The callback used for resource loading.

Remarks
  Currently WIP. This might change and / or work in an unexpected way.

## ◆ loadBuffer()

void nkGraphics::ResourceManager::loadBuffer | ( | nkMemory::StringView | path,
|  | ResourceSaveLoadCallback * | callback = `nullptr`
| ) |  |

Loads a buffer declaration file. Does it asynchronously.

Parameters

  path | The declaration path, relative to the working directory. See nkResources::ResourceManager for path naming conventions.
  callback | The callback used for resource loading.

Remarks
  Currently WIP. This might change and / or work in an unexpected way.

## ◆ loadShader()

void nkGraphics::ResourceManager::loadShader | ( | nkMemory::StringView | path,
|  | ResourceSaveLoadCallback * | callback = `nullptr`
| ) |  |

Loads a sahder declaration file. Does it asynchronously.

Parameters

  path | The declaration path, relative to the working directory. See nkResources::ResourceManager for path naming conventions.
  callback | The callback used for resource loading.

Remarks
  Currently WIP. This might change and / or work in an unexpected way.

## ◆ loadProgram()

void nkGraphics::ResourceManager::loadProgram | ( | nkMemory::StringView | path,
|  | ResourceSaveLoadCallback * | callback = `nullptr`
| ) |  |

Loads a program declaration file. Does it asynchronously.

Parameters

  path | The declaration path, relative to the working directory. See nkResources::ResourceManager for path naming conventions.
  callback | The callback used for resource loading.

Remarks
  Currently WIP. This might change and / or work in an unexpected way.

## ◆ loadMesh()

void nkGraphics::ResourceManager::loadMesh | ( | nkMemory::StringView | path,
|  | ResourceSaveLoadCallback * | callback = `nullptr`
| ) |  |

Loads a mesh declaration file. Does it asynchronously.

Parameters

  path | The declaration path, relative to the working directory. See nkResources::ResourceManager for path naming conventions.
  callback | The callback used for resource loading.

Remarks
  Currently WIP. This might change and / or work in an unexpected way.

## ◆ loadCompositor()

void nkGraphics::ResourceManager::loadCompositor | ( | nkMemory::StringView | path,
|  | nkMemory::StringView | compoToDefault = `""`,
|  | ResourceSaveLoadCallback * | callback = `nullptr`
| ) |  |

Loads a compositor declaration file. Does it asynchronously.

Parameters

  path | The declaration path, relative to the working directory. See nkResources::ResourceManager for path naming conventions.
  compoToDefault | The default name to set as a default.
  callback | The callback used for resource loading.

Remarks
  Currently WIP. This might change and / or work in an unexpected way.

## ◆ loadNode()

void nkGraphics::ResourceManager::loadNode | ( | nkMemory::StringView | path,
|  | ResourceSaveLoadCallback * | callback = `nullptr`
| ) |  |

Loads a node (scene) declaration file. Does it asynchronously.

Parameters

  path | The declaration path, relative to the working directory. See nkResources::ResourceManager for path naming conventions.
  callback | The callback used for resource loading.

Remarks
  Currently WIP. This might change and / or work in an unexpected way.

The documentation for this class was generated from the following file:

- Documentation/Headers/NilkinsGraphics/Resources/ResourceManager.h